//*******************************************************************************
// file  main.c
//
// attention
// Copyright (C) 2018 MACNICA,Inc. All Rights Reserved.\n
//   This software is licensed "AS IS". 
//   Please perform use of this software by a user's own responsibility and expense.
//   It cannot guarantee in the maker side about the damage which occurred by the ab-
//   ility not to use or use this software, and all damage that occurred secondarily.
//*******************************************************************************

/***********************************************************************************
 *  includes
 ***********************************************************************************/
#include <system.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/alt_irq.h>
#include <sys/alt_cache.h>
#include <altera_avalon_uart.h>
#include <altera_avalon_uart_regs.h>
#include <altera_msgdma_descriptor_regs.h>
#include <altera_msgdma_csr_regs.h>
#include <altera_msgdma.h>
#include <uart_avst_adapter_regs.h>

/***********************************************************************************
 *  re-definitions
 *  ̃ZNV"system.h"Œ`ꂽ萔A
 *    {\[Xt@CŎgp邽߂ɍĒ`̂łB
 *    gp̍ۂ͉E̒萔"system.h"QƂ̏AύXĂgB
 ***********************************************************************************/
#define UART_ADAPTER        (UART_AVST_ADAPTER_0_BASE)      // UART->Avalon-ST A_v^CSRAhX

#define UART_ADRS           (UART_0_BASE)                   // UART CSRAhX
#define UART_IRQ_ID         (UART_0_IRQ_INTERRUPT_CONTROLLER_ID)  // UART ̊荞݃Rg[ID
#define UART_IRQ_NO         (UART_0_IRQ)                    // UART ̊荞ݔԍ
#define UART_BITS           (UART_0_DATA_BITS)              // UART ̃f[^ bit 

#define TX_MSGDMA_NAME      (MSGDMA_0_CSR_NAME)             // Tx p mSGDMÃWX^
#define TX_BUFF_ADRS        (ONCHIP_MEMORY2_0_BASE)         // Tx pMobt@̃AhX
#define TX_BUFF_SIZE        (ONCHIP_MEMORY2_0_SIZE_VALUE)	// Tx pMobt@̃TCY

#define RX_MSGDMA_NAME      (MSGDMA_1_CSR_NAME)             // Rx pmSGDMÃWX^
#define RX_BUFF_ADRS        (ONCHIP_MEMORY2_1_BASE)         // Rx pMobt@̃AhX
#define RX_BUFF_SIZE        (ONCHIP_MEMORY2_1_SIZE_VALUE)   // Rx pMobt@̃TCY

/***********************************************************************************
 *  definitions (define, enum, typedef, etc..)
 ***********************************************************************************/
#define TX_DMA                                          // UART TxDMAsꍇ
#define RX_DMA                                          // UART RxDMAsꍇ

#define TRUE                -1
#define FALSE               0

#define UART_STAT_MSK       (ALTERA_AVALON_UART_STATUS_PE_MSK  | \
                             ALTERA_AVALON_UART_STATUS_FE_MSK  | \
                             ALTERA_AVALON_UART_STATUS_BRK_MSK | \
                             ALTERA_AVALON_UART_STATUS_ROE_MSK | \
                             ALTERA_AVALON_UART_STATUS_TOE_MSK | \
                             ALTERA_AVALON_UART_STATUS_E_MSK)

#define UART_CTRL_MSK       (ALTERA_AVALON_UART_CONTROL_PE_MSK  | \
                             ALTERA_AVALON_UART_CONTROL_FE_MSK  | \
                             ALTERA_AVALON_UART_CONTROL_BRK_MSK | \
                             ALTERA_AVALON_UART_CONTROL_ROE_MSK | \
                             ALTERA_AVALON_UART_CONTROL_TOE_MSK | \
                             ALTERA_AVALON_UART_CONTROL_E_MSK)

#define TRANS_LENGTH        128

// UART  Data bitsɍďύX
#if (UART_BITS == 9)
    typedef unsigned short  UART_DATA;  // f[^16bit
    #define DMA_MULT        2           // DMAł̓]f[^2{
#elif (UART_BITS == 8)
    typedef unsigned char   UART_DATA;  // f[^8bit
    #define DMA_MULT        1           // DMAł̓]f[^͂̂܂
#else
    typedef unsigned char   UART_DATA;  // f[^8bit
    #define DMA_MULT        1           // DMAł̓]f[^͂̂܂
#endif

/***********************************************************************************
 *  variables
 ***********************************************************************************/
volatile int rx_cmp = FALSE;    // MtO
volatile int rx_err = FALSE;    // MG[tO
volatile int tx_err = FALSE;    // MG[tO
volatile int uart_err = FALSE;  // UARTG[tO

#ifndef RX_DMA
int nRxCount = 0;                                   // UART Rx荞݂gĎMꍇ̃JE^
UART_DATA *pRxData = (UART_DATA*)(RX_BUFF_ADRS);    // UART Rx荞݂gĎMꍇ̃obt@AhX
#endif

/***********************************************************************************
 *  proto types
 ***********************************************************************************/
void dump(UART_DATA *adr, int size);                    // _v
int check(UART_DATA *adr0, UART_DATA *adr1, int size);  // `FbN

/***********************************************************************************
 *  interrupt handler
 ***********************************************************************************/
// UART 荞݃nh
static void uart_callback(void * context)
{
    alt_u32 csr = (alt_u32)context;
    alt_irq_context cpu_sr;

    // S荞݂fBZ[u
    cpu_sr = alt_irq_disable_all();

    // Rg[ Reg' ƃXe[^X Reg' ̒l擾
    int nCtl = IORD_ALTERA_AVALON_UART_CONTROL(csr);
    int nSta = IORD_ALTERA_AVALON_UART_STATUS(csr);

#ifdef RX_DMA
    // 荞݃NA
    IOWR_ALTERA_AVALON_UART_STATUS(csr, UART_STAT_MSK);

#else
    // 荞݃NA
    IOWR_ALTERA_AVALON_UART_STATUS(csr, UART_STAT_MSK | ALTERA_AVALON_UART_STATUS_RRDY_MSK);

    // RRDY Ă RX Data o
    if(nSta & ALTERA_AVALON_UART_STATUS_RRDY_MSK)
    {
        // RX BufferɏŃJE^CNg
        pRxData[nRxCount ++] = IORD_ALTERA_AVALON_UART_RXDATA(csr);
        if(nRxCount >= TRANS_LENGTH)
        {
            nRxCount = 0;
            rx_cmp = TRUE;
        }
    }
#endif
    // G[?
    if(nSta & UART_STAT_MSK)
    {
        // G[tO𗧂Ă
        uart_err = TRUE;
        printf("UART_IRQ:%X.%X\n", nSta, nCtl);
    }

    // S荞݂Cl[u
    alt_irq_enable_all(cpu_sr);
}

#ifdef TX_DMA
// Tx DMA 荞݃nh
static void tx_dma_callback(void * context)
{
    struct alt_msgdma_dev *tx_dma = (alt_msgdma_dev*)context;

    // Rg[ Reg' ƃXe[^X Reg' ̒l擾
    int nCtl = IORD_ALTERA_MSGDMA_CSR_CONTROL(tx_dma->csr_base);
    int nSta = IORD_ALTERA_MSGDMA_CSR_STATUS(tx_dma->csr_base);

    // G[?
    if(nSta & ALTERA_MSGDMA_CSR_STOPPED_ON_ERROR_MASK)
    {
        // G[tO𗧂Ă
        tx_err = TRUE;
        printf("TX_IRQ:%X.%X\n", nSta, nCtl);
    }
}
#endif

#ifdef RX_DMA
// Rx DMA 荞݃nh
static void rx_dma_callback(void * context)
{
    struct alt_msgdma_dev *tx_dma = (alt_msgdma_dev*)context;

    // Rg[ Reg' ƃXe[^X Reg' ̒l擾
    int nCtl = IORD_ALTERA_MSGDMA_CSR_CONTROL(tx_dma->csr_base);
    int nSta = IORD_ALTERA_MSGDMA_CSR_STATUS(tx_dma->csr_base);

    // w byte M?
    if(nSta & ALTERA_MSGDMA_CSR_DESCRIPTOR_BUFFER_EMPTY_MASK)
    {
        // MtO𗧂Ă
        rx_cmp = TRUE;
    }else
    {
        // ȊO̊荞݂̓G[Ƃ
        rx_err = TRUE;
        printf("RX_IRQ:%X.%X\n", nSta, nCtl);
    }
}
#endif

/***********************************************************************************
 *  main function
 ***********************************************************************************/
int main()
{
    int i;
    int tx_length;  // Mf[^

    // Tx/Rx pobt@AhXLbV̈Ŏ擾
    UART_DATA *tx_buff = (UART_DATA*)(TX_BUFF_ADRS + 0x8000000);
    UART_DATA *rx_buff = (UART_DATA*)(RX_BUFF_ADRS + 0x8000000);

#if defined(RX_DMA) && defined(TX_DMA)                                                                  // TxRxDMA]
    // UART->Avalon-ST A_v^̏
    IOWR_UART_ADAPTER_CONTROL(UART_ADAPTER, UART_ADAPTER_CTL_TX_ENABLE | UART_ADAPTER_CTL_RX_ENABLE);   // Tx/Rx Enable
    IOWR_UART_ADAPTER_INTERVAL(UART_ADAPTER, 10000);                                                    // Interval(100us) ᑬɂ Tx mSGDMA  5ms ^CAEgG[
#endif
#if defined(RX_DMA) && !defined(TX_DMA)                                                                 // Rx̂DMA]
    // UART->Avalon-ST A_v^̏
    IOWR_UART_ADAPTER_CONTROL(UART_ADAPTER, UART_ADAPTER_CTL_RX_ENABLE);                                // Rx Enable
    IOWR_UART_ADAPTER_INTERVAL(UART_ADAPTER, 10000);                                                    // Interval(100us) ᑬɂ Tx mSGDMA  5ms ^CAEgG[
#endif
#if !defined(RX_DMA) && defined(TX_DMA)                                                                 // Tx̂DMA]
    // UART->Avalon-ST A_v^̏
    IOWR_UART_ADAPTER_CONTROL(UART_ADAPTER, UART_ADAPTER_CTL_TX_ENABLE);                                // Tx Enable
    IOWR_UART_ADAPTER_INTERVAL(UART_ADAPTER, 30000);                                                    // Interval(300us) ɂ Receiver overrun error
#endif
#if !defined(RX_DMA) && !defined(TX_DMA)                                                                // TxRxDMA]Ȃ
    // UART->Avalon-ST A_v^̏
    IOWR_UART_ADAPTER_CONTROL(UART_ADAPTER, 0);                                                         // Tx/Rx Disable
    IOWR_UART_ADAPTER_INTERVAL(UART_ADAPTER, 10000);                                                    //
#endif

#ifdef RX_DMA
    // UART 荞݃}XNݒ
    IOWR_ALTERA_AVALON_UART_CONTROL(UART_ADRS, UART_CTRL_MSK);
#else
    // UART 荞݃}XNݒ(RRDY荞݂Ŏ󂯂ĎMf[^oj
    IOWR_ALTERA_AVALON_UART_CONTROL(UART_ADRS, UART_CTRL_MSK | ALTERA_AVALON_UART_CONTROL_RRDY_MSK);
#endif
    // UART 荞݃nh̓o^
    alt_ic_isr_register(UART_IRQ_ID, UART_IRQ_NO, uart_callback, (void*)UART_ADRS, 0x0);

#ifdef TX_DMA
    // Tx mSGDMA
    alt_msgdma_dev *tx_dma;
    alt_msgdma_standard_descriptor tx_desc;
    int tx_status;

    // Tx p mSGDMA I[v
    tx_dma = alt_msgdma_open(TX_MSGDMA_NAME);
    if(NULL == tx_dma)
    {
        printf("Error:TX mSGDMA Open Fail\n");
        return FALSE;
    }
    // Tx p mSGDMA ̊荞݃nho^
    alt_msgdma_register_callback(tx_dma,
                                 tx_dma_callback,
                                 ALTERA_MSGDMA_CSR_GLOBAL_INTERRUPT_MASK |
                                 ALTERA_MSGDMA_CSR_STOP_ON_ERROR_MASK |
                                 ALTERA_MSGDMA_CSR_STOP_ON_EARLY_TERMINATION_MASK,
                                 tx_dma);
#endif

#ifdef RX_DMA
    // Rx mSGDMA
    alt_msgdma_dev *rx_dma;
    alt_msgdma_standard_descriptor rx_desc;
    int rx_status;

    // Rx p mSGDMA I[v
    rx_dma = alt_msgdma_open(RX_MSGDMA_NAME);
    if(NULL == rx_dma)
    {
        printf("Error:RX mSGDMA Open Fail\n");
        return FALSE;
    }

    // Rx p mSGDMA ̊荞݃nho^
    alt_msgdma_register_callback(rx_dma,
                                 rx_dma_callback,
                                 ALTERA_MSGDMA_CSR_GLOBAL_INTERRUPT_MASK |
                                 ALTERA_MSGDMA_CSR_STOP_ON_ERROR_MASK |
                                 ALTERA_MSGDMA_CSR_STOP_ON_EARLY_TERMINATION_MASK,
                                 rx_dma);
#endif

    // M[v
    while(1)
    {
#ifdef RX_DMA
        // ]TCYő 255 + 1
        tx_length = (rand() & 255) + 1;
#else
        // ]TCY256Œ(Mf[^荞݂̒ł͕ȂߌŒƂj
        tx_length = TRANS_LENGTH;
#endif
        // Tx Mpobt@NA
        memset(tx_buff, 0xFF, TX_BUFF_SIZE);
        // Tx Mpobt@ɗf[^
        for(i = 0;i < tx_length;i ++)
        {
            tx_buff[i] = (UART_DATA)rand();
        }
        // RX Mpobt@NA
        memset(rx_buff, 0xFF, RX_BUFF_SIZE);

        printf("Trans length:%d\n", tx_length);

        // MtO𗎂Ƃ
        rx_cmp = FALSE;

#ifdef RX_DMA
        // Rx DMÃfBXNv^̍쐬
        rx_status = alt_msgdma_construct_standard_st_to_mm_descriptor(rx_dma, &rx_desc, (alt_u32*)rx_buff, tx_length * DMA_MULT,
                                                                       ALTERA_MSGDMA_DESCRIPTOR_CONTROL_TRANSFER_COMPLETE_IRQ_MASK);
        if(0 != rx_status)
        {
            printf("Error:RX DMA descriptor Fail[%d]\n", rx_status);
            return FALSE;
        }
        // Rx DMA̎MN(non blocking)
        rx_status = alt_msgdma_standard_descriptor_async_transfer(rx_dma, &rx_desc);
        if(0 != rx_status)
        {
            printf("Error:RX DMA async trans Fail[%d]\n", rx_status);
            return FALSE;
        }
#else
        // MUART݂̒ōs
#endif

        // MOɃLbVtbV
        alt_dcache_flush_all();

#ifdef TX_DMA
        // Tx DMÃfBXNv^̍쐬
        tx_status = alt_msgdma_construct_standard_mm_to_st_descriptor(tx_dma, &tx_desc, (alt_u32*)tx_buff, tx_length * DMA_MULT,
                                                                       ALTERA_MSGDMA_DESCRIPTOR_CONTROL_TRANSFER_COMPLETE_IRQ_MASK);
        if(0 != tx_status)
        {
            printf("Error:TX DMA descriptor Fail[%d]\n", tx_status);
            return FALSE;
        }
        // Tx DMȂMN(blocking)
        tx_status = alt_msgdma_standard_descriptor_sync_transfer(tx_dma, &tx_desc);
        if(0 != tx_status)
        {
            printf("Error:TX DMA sync trans Fail[%d]\n", tx_status);
            return FALSE;
        }
#else
        // ]TCY UART M
        for(i = 0;i < tx_length;)
        {
            //  Tx ReadyȂ
            if(IORD_ALTERA_AVALON_UART_STATUS(UART_ADRS) & ALTERA_AVALON_UART_STATUS_TRDY_MSK)
            {
                // Mf[^
                IOWR_ALTERA_AVALON_UART_TXDATA(UART_ADRS, tx_buff[i ++]);
                // RxDMAŎ󂯂ꍇAI[o[G[邽1usxWait
                usleep(1000);
            }
        }
#endif

        // RX DMA ]҂[v
        while(1)
        {
            // Rx DMA  Buffer Empty ɂȂΎM
            if(rx_cmp == TRUE) break;
            // DMA  UART ŃG[oĂΏI
            if(tx_err || rx_err || uart_err) break;
        }

        // Mobt@ƎMobt@̒lrAقȂĂ΃_vo͂ďI
        if(FALSE == check(tx_buff, rx_buff, tx_length))
        {
            // ]f[^̃_v
            printf("[ TX Buffer ]\n");
            dump(tx_buff, TX_BUFF_SIZE);

            printf("[ RX Buffer ]\n");
            dump(rx_buff, RX_BUFF_SIZE);

            return FALSE;
        }else
        {
            // ]OK
            printf("Verify OK!\n");
        }
    }
    return TRUE;
}

/***********************************************************************************
 *  sub function
 ***********************************************************************************/
#define PRINT_ADRS      "%04X:"
#define PRINT_CRLF      "\n"
#if (UART_BITS == 9)
#define PRINT_DATA      " %04X"
#define PRINT_ERR       "Error[%04X]: %04X:%04X\n"
#define PRINT_LINE      8
#define UART_DATA_MSK   0x1FF
#elif (UART_BITS == 8)
#define PRINT_DATA      " %02X"
#define PRINT_ERR       "Error[%04X]: %02X:%02X\n"
#define PRINT_LINE      16
#define UART_DATA_MSK   0xFF
#else
#define PRINT_DATA      " %02X"
#define PRINT_ERR       "Error[%04X]: %02X:%02X\n"
#define PRINT_LINE      16
#define UART_DATA_MSK   0x7F
#endif

void dump(UART_DATA *adr, int size)
{
    int i;

    // LbVtbV
    alt_dcache_flush_all();

    for(i = 0;i < (size / sizeof(UART_DATA));i ++)
    {
        // AhX
        if((i % PRINT_LINE == 0) && (i < size - 1))
        {
            printf(PRINT_ADRS, (i * sizeof(UART_DATA)));
        }
        // f[^
        printf(PRINT_DATA, adr[i]);
        // CR,LF
        if((i % PRINT_LINE == (PRINT_LINE - 1)) && (i < size - 1))
        {
            printf(PRINT_CRLF);
        }
    }
    printf("\n");
}

int check(UART_DATA *adr0, UART_DATA *adr1, int size)
{
    int i;
    int res = TRUE;

    // LbVtbV
    alt_dcache_flush_all();

    for(i = 0;i < (size / sizeof(UART_DATA));i ++)
    {
        if((adr0[i] & UART_DATA_MSK) != adr1[i])
        {
            printf(PRINT_ERR, (i * sizeof(UART_DATA)), (adr0[i] & UART_DATA_MSK) ,adr1[i]);
            res = FALSE;
        }
    }
    return res;
}











