//*******************************************************************************
// file  uart_avst_adapter_reg.h
//
// attention 
// Copyright (C) 2018 MACNICA,Inc. All Rights Reserved.
//   This software is licensed "AS IS". 
//   Please perform use of this software by a user's own responsibility and expense.
//   It cannot guarantee in the maker side about the damage which occurred by the ab-
//   ility not to use or use this software, and all damage that occurred secondarily.
//*******************************************************************************

#ifndef __UART_AVST_ADAPTER_REGS_H__
#define __UART_AVST_ADAPTER_REGS_H__

#include <io.h>

#define UART_ADAPTER_CONTROL_REG                0

#define IOADDR_UART_ADAPTER_CONTROL(base)        \
        __IO_CALC_ADDRESS_NATIVE(base, UART_ADAPTER_CONTROL_REG)
#define IORD_UART_ADAPTER_CONTROL(base)          \
        IORD(base, UART_ADAPTER_CONTROL_REG) 
#define IOWR_UART_ADAPTER_CONTROL(base, data)    \
        IOWR(base, UART_ADAPTER_CONTROL_REG, data)

#define UART_ADAPTER_CTL_TX_ENABLE              0x01
#define UART_ADAPTER_CTL_RX_ENABLE              0x02

#define UART_ADAPTER_INTERVAL_REG               1

#define IOADDR_UART_ADAPTER_INTERVAL(base)        \
        __IO_CALC_ADDRESS_NATIVE(base, UART_ADAPTER_INTERVAL_REG)
#define IORD_UART_ADAPTER_INTERVAL(base)          \
        IORD(base, UART_ADAPTER_INTERVAL_REG) 
#define IOWR_UART_ADAPTER_INTERVAL(base, data)    \
        IOWR(base, UART_ADAPTER_INTERVAL_REG, data)

#define UART_ADAPTER_TX_COUNT_REG               2

#define IOADDR_UART_ADAPTER_TX_COUNT(base)        \
        __IO_CALC_ADDRESS_NATIVE(base, UART_ADAPTER_TX_COUNT_REG)
#define IORD_UART_ADAPTER_TX_COUNTL(base)          \
        IORD(base, UART_ADAPTER_TX_COUNT_REG) 

#define UART_ADAPTER_RX_COUNT_REG               3

#define IOADDR_UART_ADAPTER_RX_COUNT(base)        \
        __IO_CALC_ADDRESS_NATIVE(base, UART_ADAPTER_RX_COUNT_REG)
#define IORD_UART_ADAPTER_RX_COUNT(base)          \
        IORD(base, UART_ADAPTER_RX_COUNT_REG) 

#endif /* __UART_AVST_ADAPTER_REGS_H__ */
