#*******************************************************************************
# attention 
# Copyright (C) 2018 MACNICA,Inc. All Rights Reserved.
#   This software is licensed "AS IS". 
#   Please perform use of this software by a user's own responsibility and expense.
#   It cannot guarantee in the maker side about the damage which occurred by the ab-
#   ility not to use or use this software, and all damage that occurred secondarily.
#*******************************************************************************
#
# uart_avst_adapter_driver.tcl
#

# Create a new driver
create_driver uart_avst_adapter_driver

# Associate it with some hardware known as "uart_avst_adapter"
set_sw_property hw_class_name uart_avst_adapter

# The version of this driver
set_sw_property version __VERSION_SHORT__

# This driver may be incompatible with versions of hardware less
# than specified below. Updates to hardware and device drivers
# rendering the driver incompatible with older versions of
# hardware are noted with this property assignment.
#
# Multiple-Version compatibility was introduced in version 7.1;
# prior versions are therefore excluded.
set_sw_property min_compatible_hw_version 7.1

# Initialize the driver in alt_sys_init()
set_sw_property auto_initialize false

# Location in generated BSP that above sources will be copied into
set_sw_property bsp_subdirectory drivers

# Interrupt properties: This driver supports both legacy and enhanced
# interrupt APIs, as well as ISR preemption.
set_sw_property isr_preemption_supported true
set_sw_property supported_interrupt_apis "legacy_interrupt_api enhanced_interrupt_api"

#
# Source file listings...
#

# C/C++ source files

# Include files
add_sw_property include_source inc/uart_avst_adapter_regs.h

# This driver supports HAL & UCOSII BSP (OS) types
add_sw_property supported_bsp_type HAL
add_sw_property supported_bsp_type UCOSII

# End of file
